<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetInflowReceiptsRequest StructType
 * @subpackage Structs
 */
class GetInflowReceiptsRequest extends AbstractStructBase
{
    /**
     * The PurchaseOrderCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $PurchaseOrderCode;
    /**
     * The CreatedDateRange
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreatedDateRange
     */
    public $CreatedDateRange;
    /**
     * Constructor method for GetInflowReceiptsRequest
     * @uses GetInflowReceiptsRequest::setPurchaseOrderCode()
     * @uses GetInflowReceiptsRequest::setCreatedDateRange()
     * @param string $purchaseOrderCode
     * @param \StructType\CreatedDateRange $createdDateRange
     */
    public function __construct($purchaseOrderCode = null, \StructType\CreatedDateRange $createdDateRange = null)
    {
        $this
            ->setPurchaseOrderCode($purchaseOrderCode)
            ->setCreatedDateRange($createdDateRange);
    }
    /**
     * Get PurchaseOrderCode value
     * @return string|null
     */
    public function getPurchaseOrderCode()
    {
        return $this->PurchaseOrderCode;
    }
    /**
     * Set PurchaseOrderCode value
     * @param string $purchaseOrderCode
     * @return \StructType\GetInflowReceiptsRequest
     */
    public function setPurchaseOrderCode($purchaseOrderCode = null)
    {
        // validation for constraint: string
        if (!is_null($purchaseOrderCode) && !is_string($purchaseOrderCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($purchaseOrderCode, true), gettype($purchaseOrderCode)), __LINE__);
        }
        $this->PurchaseOrderCode = $purchaseOrderCode;
        return $this;
    }
    /**
     * Get CreatedDateRange value
     * @return \StructType\CreatedDateRange|null
     */
    public function getCreatedDateRange()
    {
        return $this->CreatedDateRange;
    }
    /**
     * Set CreatedDateRange value
     * @param \StructType\CreatedDateRange $createdDateRange
     * @return \StructType\GetInflowReceiptsRequest
     */
    public function setCreatedDateRange(\StructType\CreatedDateRange $createdDateRange = null)
    {
        $this->CreatedDateRange = $createdDateRange;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetInflowReceiptsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
