<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetItemTypeInventoryResponse StructType
 * @subpackage Structs
 */
class GetItemTypeInventoryResponse extends AbstractStructBase
{
    /**
     * The Successful
     * @var bool
     */
    public $Successful;
    /**
     * The Errors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Errors
     */
    public $Errors;
    /**
     * The Warnings
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Warnings
     */
    public $Warnings;
    /**
     * The ItemTypeInventoryDetails
     * @var \StructType\ItemTypeInventoryDetails
     */
    public $ItemTypeInventoryDetails;
    /**
     * Constructor method for GetItemTypeInventoryResponse
     * @uses GetItemTypeInventoryResponse::setSuccessful()
     * @uses GetItemTypeInventoryResponse::setErrors()
     * @uses GetItemTypeInventoryResponse::setWarnings()
     * @uses GetItemTypeInventoryResponse::setItemTypeInventoryDetails()
     * @param bool $successful
     * @param \StructType\Errors $errors
     * @param \StructType\Warnings $warnings
     * @param \StructType\ItemTypeInventoryDetails $itemTypeInventoryDetails
     */
    public function __construct($successful = null, \StructType\Errors $errors = null, \StructType\Warnings $warnings = null, \StructType\ItemTypeInventoryDetails $itemTypeInventoryDetails = null)
    {
        $this
            ->setSuccessful($successful)
            ->setErrors($errors)
            ->setWarnings($warnings)
            ->setItemTypeInventoryDetails($itemTypeInventoryDetails);
    }
    /**
     * Get Successful value
     * @return bool|null
     */
    public function getSuccessful()
    {
        return $this->Successful;
    }
    /**
     * Set Successful value
     * @param bool $successful
     * @return \StructType\GetItemTypeInventoryResponse
     */
    public function setSuccessful($successful = null)
    {
        // validation for constraint: boolean
        if (!is_null($successful) && !is_bool($successful)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($successful, true), gettype($successful)), __LINE__);
        }
        $this->Successful = $successful;
        return $this;
    }
    /**
     * Get Errors value
     * @return \StructType\Errors|null
     */
    public function getErrors()
    {
        return $this->Errors;
    }
    /**
     * Set Errors value
     * @param \StructType\Errors $errors
     * @return \StructType\GetItemTypeInventoryResponse
     */
    public function setErrors(\StructType\Errors $errors = null)
    {
        $this->Errors = $errors;
        return $this;
    }
    /**
     * Get Warnings value
     * @return \StructType\Warnings|null
     */
    public function getWarnings()
    {
        return $this->Warnings;
    }
    /**
     * Set Warnings value
     * @param \StructType\Warnings $warnings
     * @return \StructType\GetItemTypeInventoryResponse
     */
    public function setWarnings(\StructType\Warnings $warnings = null)
    {
        $this->Warnings = $warnings;
        return $this;
    }
    /**
     * Get ItemTypeInventoryDetails value
     * @return \StructType\ItemTypeInventoryDetails|null
     */
    public function getItemTypeInventoryDetails()
    {
        return $this->ItemTypeInventoryDetails;
    }
    /**
     * Set ItemTypeInventoryDetails value
     * @param \StructType\ItemTypeInventoryDetails $itemTypeInventoryDetails
     * @return \StructType\GetItemTypeInventoryResponse
     */
    public function setItemTypeInventoryDetails(\StructType\ItemTypeInventoryDetails $itemTypeInventoryDetails = null)
    {
        $this->ItemTypeInventoryDetails = $itemTypeInventoryDetails;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetItemTypeInventoryResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
