<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetTaxTypeConfigurationResponse StructType
 * @subpackage Structs
 */
class GetTaxTypeConfigurationResponse extends AbstractStructBase
{
    /**
     * The Successful
     * @var bool
     */
    public $Successful;
    /**
     * The Errors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Errors
     */
    public $Errors;
    /**
     * The Warnings
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Warnings
     */
    public $Warnings;
    /**
     * The TaxTypeConfigurations
     * @var \StructType\TaxTypeConfigurations
     */
    public $TaxTypeConfigurations;
    /**
     * Constructor method for GetTaxTypeConfigurationResponse
     * @uses GetTaxTypeConfigurationResponse::setSuccessful()
     * @uses GetTaxTypeConfigurationResponse::setErrors()
     * @uses GetTaxTypeConfigurationResponse::setWarnings()
     * @uses GetTaxTypeConfigurationResponse::setTaxTypeConfigurations()
     * @param bool $successful
     * @param \StructType\Errors $errors
     * @param \StructType\Warnings $warnings
     * @param \StructType\TaxTypeConfigurations $taxTypeConfigurations
     */
    public function __construct($successful = null, \StructType\Errors $errors = null, \StructType\Warnings $warnings = null, \StructType\TaxTypeConfigurations $taxTypeConfigurations = null)
    {
        $this
            ->setSuccessful($successful)
            ->setErrors($errors)
            ->setWarnings($warnings)
            ->setTaxTypeConfigurations($taxTypeConfigurations);
    }
    /**
     * Get Successful value
     * @return bool|null
     */
    public function getSuccessful()
    {
        return $this->Successful;
    }
    /**
     * Set Successful value
     * @param bool $successful
     * @return \StructType\GetTaxTypeConfigurationResponse
     */
    public function setSuccessful($successful = null)
    {
        // validation for constraint: boolean
        if (!is_null($successful) && !is_bool($successful)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($successful, true), gettype($successful)), __LINE__);
        }
        $this->Successful = $successful;
        return $this;
    }
    /**
     * Get Errors value
     * @return \StructType\Errors|null
     */
    public function getErrors()
    {
        return $this->Errors;
    }
    /**
     * Set Errors value
     * @param \StructType\Errors $errors
     * @return \StructType\GetTaxTypeConfigurationResponse
     */
    public function setErrors(\StructType\Errors $errors = null)
    {
        $this->Errors = $errors;
        return $this;
    }
    /**
     * Get Warnings value
     * @return \StructType\Warnings|null
     */
    public function getWarnings()
    {
        return $this->Warnings;
    }
    /**
     * Set Warnings value
     * @param \StructType\Warnings $warnings
     * @return \StructType\GetTaxTypeConfigurationResponse
     */
    public function setWarnings(\StructType\Warnings $warnings = null)
    {
        $this->Warnings = $warnings;
        return $this;
    }
    /**
     * Get TaxTypeConfigurations value
     * @return \StructType\TaxTypeConfigurations|null
     */
    public function getTaxTypeConfigurations()
    {
        return $this->TaxTypeConfigurations;
    }
    /**
     * Set TaxTypeConfigurations value
     * @param \StructType\TaxTypeConfigurations $taxTypeConfigurations
     * @return \StructType\GetTaxTypeConfigurationResponse
     */
    public function setTaxTypeConfigurations(\StructType\TaxTypeConfigurations $taxTypeConfigurations = null)
    {
        $this->TaxTypeConfigurations = $taxTypeConfigurations;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetTaxTypeConfigurationResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
