<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InflowReceiptItems StructType
 * @subpackage Structs
 */
class InflowReceiptItems extends AbstractStructBase
{
    /**
     * The InflowReceiptItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\InflowReceiptItem[]
     */
    public $InflowReceiptItem;
    /**
     * Constructor method for InflowReceiptItems
     * @uses InflowReceiptItems::setInflowReceiptItem()
     * @param \StructType\InflowReceiptItem[] $inflowReceiptItem
     */
    public function __construct(array $inflowReceiptItem = array())
    {
        $this
            ->setInflowReceiptItem($inflowReceiptItem);
    }
    /**
     * Get InflowReceiptItem value
     * @return \StructType\InflowReceiptItem[]|null
     */
    public function getInflowReceiptItem()
    {
        return $this->InflowReceiptItem;
    }
    /**
     * This method is responsible for validating the values passed to the setInflowReceiptItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInflowReceiptItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInflowReceiptItemForArrayConstraintsFromSetInflowReceiptItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $inflowReceiptItemsInflowReceiptItemItem) {
            // validation for constraint: itemType
            if (!$inflowReceiptItemsInflowReceiptItemItem instanceof \StructType\InflowReceiptItem) {
                $invalidValues[] = is_object($inflowReceiptItemsInflowReceiptItemItem) ? get_class($inflowReceiptItemsInflowReceiptItemItem) : sprintf('%s(%s)', gettype($inflowReceiptItemsInflowReceiptItemItem), var_export($inflowReceiptItemsInflowReceiptItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InflowReceiptItem property can only contain items of type \StructType\InflowReceiptItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InflowReceiptItem value
     * @throws \InvalidArgumentException
     * @param \StructType\InflowReceiptItem[] $inflowReceiptItem
     * @return \StructType\InflowReceiptItems
     */
    public function setInflowReceiptItem(array $inflowReceiptItem = array())
    {
        // validation for constraint: array
        if ('' !== ($inflowReceiptItemArrayErrorMessage = self::validateInflowReceiptItemForArrayConstraintsFromSetInflowReceiptItem($inflowReceiptItem))) {
            throw new \InvalidArgumentException($inflowReceiptItemArrayErrorMessage, __LINE__);
        }
        $this->InflowReceiptItem = $inflowReceiptItem;
        return $this;
    }
    /**
     * Add item to InflowReceiptItem value
     * @throws \InvalidArgumentException
     * @param \StructType\InflowReceiptItem $item
     * @return \StructType\InflowReceiptItems
     */
    public function addToInflowReceiptItem(\StructType\InflowReceiptItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InflowReceiptItem) {
            throw new \InvalidArgumentException(sprintf('The InflowReceiptItem property can only contain items of type \StructType\InflowReceiptItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InflowReceiptItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InflowReceiptItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
