<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InflowReceipts StructType
 * @subpackage Structs
 */
class InflowReceipts extends AbstractStructBase
{
    /**
     * The InflowReceipt
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var string[]
     */
    public $InflowReceipt;
    /**
     * Constructor method for InflowReceipts
     * @uses InflowReceipts::setInflowReceipt()
     * @param string[] $inflowReceipt
     */
    public function __construct(array $inflowReceipt = array())
    {
        $this
            ->setInflowReceipt($inflowReceipt);
    }
    /**
     * Get InflowReceipt value
     * @return string[]|null
     */
    public function getInflowReceipt()
    {
        return $this->InflowReceipt;
    }
    /**
     * This method is responsible for validating the values passed to the setInflowReceipt method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInflowReceipt method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInflowReceiptForArrayConstraintsFromSetInflowReceipt(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $inflowReceiptsInflowReceiptItem) {
            // validation for constraint: itemType
            if (!is_string($inflowReceiptsInflowReceiptItem)) {
                $invalidValues[] = is_object($inflowReceiptsInflowReceiptItem) ? get_class($inflowReceiptsInflowReceiptItem) : sprintf('%s(%s)', gettype($inflowReceiptsInflowReceiptItem), var_export($inflowReceiptsInflowReceiptItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InflowReceipt property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InflowReceipt value
     * @throws \InvalidArgumentException
     * @param string[] $inflowReceipt
     * @return \StructType\InflowReceipts
     */
    public function setInflowReceipt(array $inflowReceipt = array())
    {
        // validation for constraint: array
        if ('' !== ($inflowReceiptArrayErrorMessage = self::validateInflowReceiptForArrayConstraintsFromSetInflowReceipt($inflowReceipt))) {
            throw new \InvalidArgumentException($inflowReceiptArrayErrorMessage, __LINE__);
        }
        $this->InflowReceipt = $inflowReceipt;
        return $this;
    }
    /**
     * Add item to InflowReceipt value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\InflowReceipts
     */
    public function addToInflowReceipt($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The InflowReceipt property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InflowReceipt[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InflowReceipts
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
