<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReversePickupItems StructType
 * @subpackage Structs
 */
class ReversePickupItems extends AbstractStructBase
{
    /**
     * The ReversePickupItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\ReversePickupItem[]
     */
    public $ReversePickupItem;
    /**
     * Constructor method for ReversePickupItems
     * @uses ReversePickupItems::setReversePickupItem()
     * @param \StructType\ReversePickupItem[] $reversePickupItem
     */
    public function __construct(array $reversePickupItem = array())
    {
        $this
            ->setReversePickupItem($reversePickupItem);
    }
    /**
     * Get ReversePickupItem value
     * @return \StructType\ReversePickupItem[]|null
     */
    public function getReversePickupItem()
    {
        return $this->ReversePickupItem;
    }
    /**
     * This method is responsible for validating the values passed to the setReversePickupItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReversePickupItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReversePickupItemForArrayConstraintsFromSetReversePickupItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $reversePickupItemsReversePickupItemItem) {
            // validation for constraint: itemType
            if (!$reversePickupItemsReversePickupItemItem instanceof \StructType\ReversePickupItem) {
                $invalidValues[] = is_object($reversePickupItemsReversePickupItemItem) ? get_class($reversePickupItemsReversePickupItemItem) : sprintf('%s(%s)', gettype($reversePickupItemsReversePickupItemItem), var_export($reversePickupItemsReversePickupItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReversePickupItem property can only contain items of type \StructType\ReversePickupItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReversePickupItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ReversePickupItem[] $reversePickupItem
     * @return \StructType\ReversePickupItems
     */
    public function setReversePickupItem(array $reversePickupItem = array())
    {
        // validation for constraint: array
        if ('' !== ($reversePickupItemArrayErrorMessage = self::validateReversePickupItemForArrayConstraintsFromSetReversePickupItem($reversePickupItem))) {
            throw new \InvalidArgumentException($reversePickupItemArrayErrorMessage, __LINE__);
        }
        $this->ReversePickupItem = $reversePickupItem;
        return $this;
    }
    /**
     * Add item to ReversePickupItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ReversePickupItem $item
     * @return \StructType\ReversePickupItems
     */
    public function addToReversePickupItem(\StructType\ReversePickupItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReversePickupItem) {
            throw new \InvalidArgumentException(sprintf('The ReversePickupItem property can only contain items of type \StructType\ReversePickupItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReversePickupItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ReversePickupItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
