<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaleOrderAddressItems StructType
 * @subpackage Structs
 */
class SaleOrderAddressItems extends AbstractStructBase
{
    /**
     * The SaleOrderAddressItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\SaleOrderAddressItem[]
     */
    public $SaleOrderAddressItem;
    /**
     * Constructor method for SaleOrderAddressItems
     * @uses SaleOrderAddressItems::setSaleOrderAddressItem()
     * @param \StructType\SaleOrderAddressItem[] $saleOrderAddressItem
     */
    public function __construct(array $saleOrderAddressItem = array())
    {
        $this
            ->setSaleOrderAddressItem($saleOrderAddressItem);
    }
    /**
     * Get SaleOrderAddressItem value
     * @return \StructType\SaleOrderAddressItem[]|null
     */
    public function getSaleOrderAddressItem()
    {
        return $this->SaleOrderAddressItem;
    }
    /**
     * This method is responsible for validating the values passed to the setSaleOrderAddressItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSaleOrderAddressItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSaleOrderAddressItemForArrayConstraintsFromSetSaleOrderAddressItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $saleOrderAddressItemsSaleOrderAddressItemItem) {
            // validation for constraint: itemType
            if (!$saleOrderAddressItemsSaleOrderAddressItemItem instanceof \StructType\SaleOrderAddressItem) {
                $invalidValues[] = is_object($saleOrderAddressItemsSaleOrderAddressItemItem) ? get_class($saleOrderAddressItemsSaleOrderAddressItemItem) : sprintf('%s(%s)', gettype($saleOrderAddressItemsSaleOrderAddressItemItem), var_export($saleOrderAddressItemsSaleOrderAddressItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SaleOrderAddressItem property can only contain items of type \StructType\SaleOrderAddressItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SaleOrderAddressItem value
     * @throws \InvalidArgumentException
     * @param \StructType\SaleOrderAddressItem[] $saleOrderAddressItem
     * @return \StructType\SaleOrderAddressItems
     */
    public function setSaleOrderAddressItem(array $saleOrderAddressItem = array())
    {
        // validation for constraint: array
        if ('' !== ($saleOrderAddressItemArrayErrorMessage = self::validateSaleOrderAddressItemForArrayConstraintsFromSetSaleOrderAddressItem($saleOrderAddressItem))) {
            throw new \InvalidArgumentException($saleOrderAddressItemArrayErrorMessage, __LINE__);
        }
        $this->SaleOrderAddressItem = $saleOrderAddressItem;
        return $this;
    }
    /**
     * Add item to SaleOrderAddressItem value
     * @throws \InvalidArgumentException
     * @param \StructType\SaleOrderAddressItem $item
     * @return \StructType\SaleOrderAddressItems
     */
    public function addToSaleOrderAddressItem(\StructType\SaleOrderAddressItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SaleOrderAddressItem) {
            throw new \InvalidArgumentException(sprintf('The SaleOrderAddressItem property can only contain items of type \StructType\SaleOrderAddressItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SaleOrderAddressItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SaleOrderAddressItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
