<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaleOrderItemAlternates StructType
 * @subpackage Structs
 */
class SaleOrderItemAlternates extends AbstractStructBase
{
    /**
     * The SaleOrderItemAlternate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\SaleOrderItemAlternate[]
     */
    public $SaleOrderItemAlternate;
    /**
     * Constructor method for SaleOrderItemAlternates
     * @uses SaleOrderItemAlternates::setSaleOrderItemAlternate()
     * @param \StructType\SaleOrderItemAlternate[] $saleOrderItemAlternate
     */
    public function __construct(array $saleOrderItemAlternate = array())
    {
        $this
            ->setSaleOrderItemAlternate($saleOrderItemAlternate);
    }
    /**
     * Get SaleOrderItemAlternate value
     * @return \StructType\SaleOrderItemAlternate[]|null
     */
    public function getSaleOrderItemAlternate()
    {
        return $this->SaleOrderItemAlternate;
    }
    /**
     * This method is responsible for validating the values passed to the setSaleOrderItemAlternate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSaleOrderItemAlternate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSaleOrderItemAlternateForArrayConstraintsFromSetSaleOrderItemAlternate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $saleOrderItemAlternatesSaleOrderItemAlternateItem) {
            // validation for constraint: itemType
            if (!$saleOrderItemAlternatesSaleOrderItemAlternateItem instanceof \StructType\SaleOrderItemAlternate) {
                $invalidValues[] = is_object($saleOrderItemAlternatesSaleOrderItemAlternateItem) ? get_class($saleOrderItemAlternatesSaleOrderItemAlternateItem) : sprintf('%s(%s)', gettype($saleOrderItemAlternatesSaleOrderItemAlternateItem), var_export($saleOrderItemAlternatesSaleOrderItemAlternateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SaleOrderItemAlternate property can only contain items of type \StructType\SaleOrderItemAlternate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SaleOrderItemAlternate value
     * @throws \InvalidArgumentException
     * @param \StructType\SaleOrderItemAlternate[] $saleOrderItemAlternate
     * @return \StructType\SaleOrderItemAlternates
     */
    public function setSaleOrderItemAlternate(array $saleOrderItemAlternate = array())
    {
        // validation for constraint: array
        if ('' !== ($saleOrderItemAlternateArrayErrorMessage = self::validateSaleOrderItemAlternateForArrayConstraintsFromSetSaleOrderItemAlternate($saleOrderItemAlternate))) {
            throw new \InvalidArgumentException($saleOrderItemAlternateArrayErrorMessage, __LINE__);
        }
        $this->SaleOrderItemAlternate = $saleOrderItemAlternate;
        return $this;
    }
    /**
     * Add item to SaleOrderItemAlternate value
     * @throws \InvalidArgumentException
     * @param \StructType\SaleOrderItemAlternate $item
     * @return \StructType\SaleOrderItemAlternates
     */
    public function addToSaleOrderItemAlternate(\StructType\SaleOrderItemAlternate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SaleOrderItemAlternate) {
            throw new \InvalidArgumentException(sprintf('The SaleOrderItemAlternate property can only contain items of type \StructType\SaleOrderItemAlternate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SaleOrderItemAlternate[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SaleOrderItemAlternates
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
