<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaleOrders StructType
 * @subpackage Structs
 */
class SaleOrders extends AbstractStructBase
{
    /**
     * The SaleOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SaleOrder[]
     */
    public $SaleOrder;
    /**
     * Constructor method for SaleOrders
     * @uses SaleOrders::setSaleOrder()
     * @param \StructType\SaleOrder[] $saleOrder
     */
    public function __construct(array $saleOrder = array())
    {
        $this
            ->setSaleOrder($saleOrder);
    }
    /**
     * Get SaleOrder value
     * @return \StructType\SaleOrder[]|null
     */
    public function getSaleOrder()
    {
        return $this->SaleOrder;
    }
    /**
     * This method is responsible for validating the values passed to the setSaleOrder method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSaleOrder method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSaleOrderForArrayConstraintsFromSetSaleOrder(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $saleOrdersSaleOrderItem) {
            // validation for constraint: itemType
            if (!$saleOrdersSaleOrderItem instanceof \StructType\SaleOrder) {
                $invalidValues[] = is_object($saleOrdersSaleOrderItem) ? get_class($saleOrdersSaleOrderItem) : sprintf('%s(%s)', gettype($saleOrdersSaleOrderItem), var_export($saleOrdersSaleOrderItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SaleOrder property can only contain items of type \StructType\SaleOrder, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SaleOrder value
     * @throws \InvalidArgumentException
     * @param \StructType\SaleOrder[] $saleOrder
     * @return \StructType\SaleOrders
     */
    public function setSaleOrder(array $saleOrder = array())
    {
        // validation for constraint: array
        if ('' !== ($saleOrderArrayErrorMessage = self::validateSaleOrderForArrayConstraintsFromSetSaleOrder($saleOrder))) {
            throw new \InvalidArgumentException($saleOrderArrayErrorMessage, __LINE__);
        }
        $this->SaleOrder = $saleOrder;
        return $this;
    }
    /**
     * Add item to SaleOrder value
     * @throws \InvalidArgumentException
     * @param \StructType\SaleOrder $item
     * @return \StructType\SaleOrders
     */
    public function addToSaleOrder(\StructType\SaleOrder $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SaleOrder) {
            throw new \InvalidArgumentException(sprintf('The SaleOrder property can only contain items of type \StructType\SaleOrder, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SaleOrder[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SaleOrders
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
