<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShippingProviders StructType
 * @subpackage Structs
 */
class ShippingProviders extends AbstractStructBase
{
    /**
     * The ShippingProvider
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\ShippingProvider[]
     */
    public $ShippingProvider;
    /**
     * Constructor method for ShippingProviders
     * @uses ShippingProviders::setShippingProvider()
     * @param \StructType\ShippingProvider[] $shippingProvider
     */
    public function __construct(array $shippingProvider = array())
    {
        $this
            ->setShippingProvider($shippingProvider);
    }
    /**
     * Get ShippingProvider value
     * @return \StructType\ShippingProvider[]|null
     */
    public function getShippingProvider()
    {
        return $this->ShippingProvider;
    }
    /**
     * This method is responsible for validating the values passed to the setShippingProvider method
     * This method is willingly generated in order to preserve the one-line inline validation within the setShippingProvider method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateShippingProviderForArrayConstraintsFromSetShippingProvider(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $shippingProvidersShippingProviderItem) {
            // validation for constraint: itemType
            if (!$shippingProvidersShippingProviderItem instanceof \StructType\ShippingProvider) {
                $invalidValues[] = is_object($shippingProvidersShippingProviderItem) ? get_class($shippingProvidersShippingProviderItem) : sprintf('%s(%s)', gettype($shippingProvidersShippingProviderItem), var_export($shippingProvidersShippingProviderItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ShippingProvider property can only contain items of type \StructType\ShippingProvider, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ShippingProvider value
     * @throws \InvalidArgumentException
     * @param \StructType\ShippingProvider[] $shippingProvider
     * @return \StructType\ShippingProviders
     */
    public function setShippingProvider(array $shippingProvider = array())
    {
        // validation for constraint: array
        if ('' !== ($shippingProviderArrayErrorMessage = self::validateShippingProviderForArrayConstraintsFromSetShippingProvider($shippingProvider))) {
            throw new \InvalidArgumentException($shippingProviderArrayErrorMessage, __LINE__);
        }
        $this->ShippingProvider = $shippingProvider;
        return $this;
    }
    /**
     * Add item to ShippingProvider value
     * @throws \InvalidArgumentException
     * @param \StructType\ShippingProvider $item
     * @return \StructType\ShippingProviders
     */
    public function addToShippingProvider(\StructType\ShippingProvider $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ShippingProvider) {
            throw new \InvalidArgumentException(sprintf('The ShippingProvider property can only contain items of type \StructType\ShippingProvider, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ShippingProvider[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ShippingProviders
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
