<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SplitSaleOrderItems StructType
 * @subpackage Structs
 */
class SplitSaleOrderItems extends AbstractStructBase
{
    /**
     * The SplitSaleOrderItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\SplitSaleOrderItem[]
     */
    public $SplitSaleOrderItem;
    /**
     * Constructor method for SplitSaleOrderItems
     * @uses SplitSaleOrderItems::setSplitSaleOrderItem()
     * @param \StructType\SplitSaleOrderItem[] $splitSaleOrderItem
     */
    public function __construct(array $splitSaleOrderItem = array())
    {
        $this
            ->setSplitSaleOrderItem($splitSaleOrderItem);
    }
    /**
     * Get SplitSaleOrderItem value
     * @return \StructType\SplitSaleOrderItem[]|null
     */
    public function getSplitSaleOrderItem()
    {
        return $this->SplitSaleOrderItem;
    }
    /**
     * This method is responsible for validating the values passed to the setSplitSaleOrderItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSplitSaleOrderItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSplitSaleOrderItemForArrayConstraintsFromSetSplitSaleOrderItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $splitSaleOrderItemsSplitSaleOrderItemItem) {
            // validation for constraint: itemType
            if (!$splitSaleOrderItemsSplitSaleOrderItemItem instanceof \StructType\SplitSaleOrderItem) {
                $invalidValues[] = is_object($splitSaleOrderItemsSplitSaleOrderItemItem) ? get_class($splitSaleOrderItemsSplitSaleOrderItemItem) : sprintf('%s(%s)', gettype($splitSaleOrderItemsSplitSaleOrderItemItem), var_export($splitSaleOrderItemsSplitSaleOrderItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SplitSaleOrderItem property can only contain items of type \StructType\SplitSaleOrderItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SplitSaleOrderItem value
     * @throws \InvalidArgumentException
     * @param \StructType\SplitSaleOrderItem[] $splitSaleOrderItem
     * @return \StructType\SplitSaleOrderItems
     */
    public function setSplitSaleOrderItem(array $splitSaleOrderItem = array())
    {
        // validation for constraint: array
        if ('' !== ($splitSaleOrderItemArrayErrorMessage = self::validateSplitSaleOrderItemForArrayConstraintsFromSetSplitSaleOrderItem($splitSaleOrderItem))) {
            throw new \InvalidArgumentException($splitSaleOrderItemArrayErrorMessage, __LINE__);
        }
        $this->SplitSaleOrderItem = $splitSaleOrderItem;
        return $this;
    }
    /**
     * Add item to SplitSaleOrderItem value
     * @throws \InvalidArgumentException
     * @param \StructType\SplitSaleOrderItem $item
     * @return \StructType\SplitSaleOrderItems
     */
    public function addToSplitSaleOrderItem(\StructType\SplitSaleOrderItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SplitSaleOrderItem) {
            throw new \InvalidArgumentException(sprintf('The SplitSaleOrderItem property can only contain items of type \StructType\SplitSaleOrderItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SplitSaleOrderItem[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SplitSaleOrderItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
