<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SplittedShippingPackages StructType
 * @subpackage Structs
 */
class SplittedShippingPackages extends AbstractStructBase
{
    /**
     * The ShippingPackage
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\ShippingPackage[]
     */
    public $ShippingPackage;
    /**
     * Constructor method for SplittedShippingPackages
     * @uses SplittedShippingPackages::setShippingPackage()
     * @param \StructType\ShippingPackage[] $shippingPackage
     */
    public function __construct(array $shippingPackage = array())
    {
        $this
            ->setShippingPackage($shippingPackage);
    }
    /**
     * Get ShippingPackage value
     * @return \StructType\ShippingPackage[]|null
     */
    public function getShippingPackage()
    {
        return $this->ShippingPackage;
    }
    /**
     * This method is responsible for validating the values passed to the setShippingPackage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setShippingPackage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateShippingPackageForArrayConstraintsFromSetShippingPackage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $splittedShippingPackagesShippingPackageItem) {
            // validation for constraint: itemType
            if (!$splittedShippingPackagesShippingPackageItem instanceof \StructType\ShippingPackage) {
                $invalidValues[] = is_object($splittedShippingPackagesShippingPackageItem) ? get_class($splittedShippingPackagesShippingPackageItem) : sprintf('%s(%s)', gettype($splittedShippingPackagesShippingPackageItem), var_export($splittedShippingPackagesShippingPackageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ShippingPackage property can only contain items of type \StructType\ShippingPackage, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ShippingPackage value
     * @throws \InvalidArgumentException
     * @param \StructType\ShippingPackage[] $shippingPackage
     * @return \StructType\SplittedShippingPackages
     */
    public function setShippingPackage(array $shippingPackage = array())
    {
        // validation for constraint: array
        if ('' !== ($shippingPackageArrayErrorMessage = self::validateShippingPackageForArrayConstraintsFromSetShippingPackage($shippingPackage))) {
            throw new \InvalidArgumentException($shippingPackageArrayErrorMessage, __LINE__);
        }
        $this->ShippingPackage = $shippingPackage;
        return $this;
    }
    /**
     * Add item to ShippingPackage value
     * @throws \InvalidArgumentException
     * @param \StructType\ShippingPackage $item
     * @return \StructType\SplittedShippingPackages
     */
    public function addToShippingPackage(\StructType\ShippingPackage $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ShippingPackage) {
            throw new \InvalidArgumentException(sprintf('The ShippingPackage property can only contain items of type \StructType\ShippingPackage, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ShippingPackage[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SplittedShippingPackages
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
